include get.e
include graphics.e

global procedure square(atom x1, atom y1, atom x2, atom y2, atom colour)
         polygon(colour,1,{{x1,y1},{x1,y2},{x2,y2},{x2,y1}})
end procedure

global procedure nl(integer fn)
          puts(fn, "\n")
end procedure

global function sum(sequence seq)
         atom total

         total = 0
         for i = 1 to length(seq) do
            total += seq[i]
         end for
         return total
end function

global function allTrue(object tf)
       if atom(tf) then
          return tf
       end if
       for i = 1 to length(tf) do
           if tf[i] = 0 then
              return 0
           end if
       end for
       return 1
end function

global function getYesNo()
       integer choice

       choice = 0
       while choice != 'y' and choice != 'n' do
             choice = wait_key()
       end while
       return choice
end function

global function aOr(sequence teo)

       for i = 1 to length(teo) do
           if teo[i] = 1 then
              return 1
           end if
       end for
       return 0
end function

global function radians(atom degrees)
       return degrees * (PI / 180)
end function

global function removeItem(sequence seq, integer item)
       if item = 1 then
          if length(seq) = 1 then
             return {}
          elsif length(seq) = 2 then
             return {seq[2]}
          else
             return seq[2..length(seq)]
          end if
       elsif item = length(seq) then
          if length(seq) = 2 then
             return {seq[1]}
          else
             return seq[1..length(seq) - 1]
          end if
       else
          return seq[1..item - 1] & seq[item + 1..length(seq)]
       end if
end function

global function readFile(integer fn)
       integer char
       sequence tempData

       tempData = ""
       char = 0
       while char != -1 do
          char = getc(fn)
          tempData &= char
       end while
       tempData = tempData[1..length(tempData) - 1]
       return tempData
end function

global function findNo(object item, sequence seq)
       integer number

       number = 0
       for i = 1 to length(seq) do
           if equal(item, seq[i]) then
              number += 1
           end if
       end for

       return number
end function

global function multiPrompt(sequence prompt)
       sequence string

       puts(1, prompt & "\n")
       string = readFile(0)
       for i = 1 to findNo('\n', string) + 1 do
           puts(1, '\n')
       end for

       return string
end function

global function trim(sequence string)
       if length(string) = 0 then
          return ""
       end if
       while string[1] = ' ' do
             string = string[2..length(string)]
       end while
       while string[length(string)] = ' ' do
             string = string[1..length(string) - 1]
       end while

       return string
end function
